#!/bin/sh

# Make sure only root can run our script
if [ "$(id -u)" != "0" ]; then
  echo "This script must be run as root" 1>&2
  exit 1
fi

<% if node['infrastructure'] == "ami" %>
# Use command line scripts to get instance ID and public hostname
IPV4=$(ec2metadata | grep 'public-ipv4:' | cut -d ' ' -f 2)
if [ "$IPV4" = "unavailable" ] || [ -z "$IPV4" ]; then
  IPV4=$(ec2metadata | grep 'local-ipv4:' | cut -d ' ' -f 2)
fi
if [ "$IPV4" = "unavailable" ] || [ -z "$IPV4" ]; then
  IPV4=$(ifconfig | grep Bcast | tail -n 1 | cut -d ':' -f 2 | cut -d ' ' -f 1)
fi
<% else %>
IPV4=$(ifconfig | grep Bcast | tail -n 1 | cut -d ':' -f 2 | cut -d ' ' -f 1)
<% end %>

# Fix our index page
sed -i -r "s/https:\/\/([0-9]{1,3}\.){3}[0-9]{1,3}/https:\/\/$IPV4/g" <%= node['apache']['docroot_dir'] %>/index.html
sed -i -r "s/https?:\/\/([0-9]{1,3}\.){3}[0-9]{1,3}/https:\/\/$IPV4/g" <%= node['apache']['dir'] %>/sites-available/*.conf

# Restart Apache2
service apache2 reload

<% if ::File.directory?(node['jenkins']['home_dir']) %>
# Fix our jenkins URL
sed -i -r "s/https:\/\/([0-9]{1,3}\.){3}[0-9]{1,3}/https:\/\/$IPV4/g" <%= node['jenkins']['home_dir'] %>/jenkins.model.JenkinsLocationConfiguration.xml

# Fix our trac ini file
sed -i -r "s/https:\/\/([0-9]{1,3}\.){3}[0-9]{1,3}/https:\/\/$IPV4/g" <%= node['trac']['project']['dir'] %>/conf/trac.ini
<% end %>

<% if ::File.directory?(node['gitblit']['home']) %>
# Fix our gitblit url
sed -i -r "s/https:\/\/([0-9]{1,3}\.){3}[0-9]{1,3}/https:\/\/$IPV4/g" <%= node['gitblit']['data'] %>/gitblit.properties
sed -i -r "s/https:\/\/([0-9]{1,3}\.){3}[0-9]{1,3}/https:\/\/$IPV4/g" <%= node['gitblit']['groovy'] %>/jenkins.groovy
<% end %>
